Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_iso.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_iso.F90	(revision 2082)
@@ -28,4 +28,5 @@
    USE ldfslp          ! iso-neutral slopes
    USE diaptr          ! poleward transport diagnostics
+   USE trc_oce         ! share passive tracers/Ocean variables
 #if defined key_diaar5
    USE phycst          ! physical constants
@@ -116,7 +117,7 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( ( cdtype == 'TRA' .AND. kt == nit000 ) .OR. ( cdtype == 'TRC' .AND. kt == nittrc000 ) )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_iso : rotated laplacian diffusion operator'
+         IF(lwp) WRITE(numout,*) 'tra_ldf_iso : rotated laplacian diffusion operator on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       ENDIF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_lap.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 2082)
@@ -23,4 +23,5 @@
    USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
+   USE trc_oce         ! share passive tracers/Ocean variables
 
 
@@ -84,7 +85,7 @@
       !!----------------------------------------------------------------------
       
-      IF( kt == nit000 ) THEN
+      IF( ( cdtype == 'TRA' .AND. kt == nit000 ) .OR. ( cdtype == 'TRC' .AND. kt == nittrc000 ) )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_lap : iso-level laplacian diffusion'
+         IF(lwp) WRITE(numout,*) 'tra_ldf_lap : iso-level laplacian diffusion on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~ '
          e1ur(:,:) = e2u(:,:) / e1u(:,:)
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranpc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2082)
@@ -74,5 +74,5 @@
          inpci = 0
 
-         CALL eos( tsa(:,:,:,jp_tem), tsa(:,:,:,jp_sal), rhd, zrhop )         ! Potential density
+         CALL eos( tsa, rhd, zrhop )         ! Potential density
 
          IF( l_trdtra )   THEN                    !* Save ta and sa trends
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 2082)
@@ -48,5 +48,5 @@
    PUBLIC   tra_nxt_vvl   ! to be used in trcnxt
 
-   REAL(wp), DIMENSION(jpk) ::   r2dt_t   ! vertical profile time step, =2*rdttra (leapfrog) or =rdttra (Euler)
+   REAL(wp), DIMENSION(jpk) ::   r2dt   ! vertical profile time step, =2*rdttra (leapfrog) or =rdttra (Euler)
 
    !! * Substitutions
@@ -120,6 +120,6 @@
  
       ! set time step size (Euler/Leapfrog)
-      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   r2dt_t(:) =     rdttra(:)      ! at nit000             (Euler)
-      ELSEIF( kt <= nit000 + 1 )           THEN   ;   r2dt_t(:) = 2.* rdttra(:)      ! at nit000 or nit000+1 (Leapfrog)
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   r2dt(:) =     rdttra(:)      ! at nit000             (Euler)
+      ELSEIF( kt <= nit000 + 1 )           THEN   ;   r2dt(:) = 2.* rdttra(:)      ! at nit000 or nit000+1 (Leapfrog)
       ENDIF
 
@@ -145,5 +145,5 @@
       IF( l_trdtra ) THEN              ! trend of the Asselin filter (tb filtered - tb)/dt     
          DO jk = 1, jpkm1
-            zfact = 1.e0 / r2dt_t(jk)             
+            zfact = 1.e0 / r2dt(jk)             
             ztrdt(:,:,jk) = ( tsb(:,:,jk,jp_tem) - ztrdt(:,:,jk) ) * zfact
             ztrds(:,:,jk) = ( tsb(:,:,jk,jp_sal) - ztrds(:,:,jk) ) * zfact
@@ -194,5 +194,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == kit000 ) THEN
+      IF( kt == kit000 )  THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'tra_nxt_fix : time stepping'
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_exp.F90	(revision 2082)
@@ -29,4 +29,5 @@
    USE zdfddm          ! ocean vertical physics: double diffusion
    USE in_out_manager  ! I/O manager
+   USE trc_oce         ! share passive tracers/Ocean variables
 
    IMPLICIT NONE
@@ -87,7 +88,7 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( ( cdtype == 'TRA' .AND. kt == nit000 ) .OR. ( cdtype == 'TRC' .AND. kt == nittrc000 ) )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_zdf_exp : explicit vertical mixing'
+         IF(lwp) WRITE(numout,*) 'tra_zdf_exp : explicit vertical mixing on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       ENDIF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_imp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/trazdf_imp.F90	(revision 2082)
@@ -31,4 +31,5 @@
    USE domvvl          ! variable volume
    USE ldftra          ! lateral mixing type
+   USE trc_oce         ! share passive tracers/Ocean variables
 
    IMPLICIT NONE
@@ -105,7 +106,7 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( ( cdtype == 'TRA' .AND. kt == nit000 ) .OR. ( cdtype == 'TRC' .AND. kt == nittrc000 ) )  THEN
          IF(lwp)WRITE(numout,*)
-         IF(lwp)WRITE(numout,*) 'tra_zdf_imp : implicit vertical mixing'
+         IF(lwp)WRITE(numout,*) 'tra_zdf_imp : implicit vertical mixing on ', cdtype
          IF(lwp)WRITE(numout,*) '~~~~~~~~~~~ '
          zavi = 0.e0      ! avoid warning at compilation phase when lk_ldfslp=F
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2082)
@@ -14,6 +14,4 @@
    !!   zps_hde      :  Horizontal DErivative of T, S and rd at the last
    !!                   ocean level (Z-coord. with Partial Steps)
-   !!   zps_hde_trc  :  Horizontal DErivative of passive tracers at the last
-   !!                   ocean level (Z-coord. with Partial Steps)
    !!----------------------------------------------------------------------
    !! * Modules used
@@ -31,7 +29,4 @@
    PUBLIC zps_hde          ! routine called by step.F90
    PUBLIC zps_hde_init     ! routine called by opa.F90
-#if defined key_top
-   PUBLIC zps_hde_trc 
-#endif
 
    !! * module variables
@@ -49,7 +44,7 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE zps_hde ( kt, ptem, psal, prd ,   &
-                            pgtu, pgsu, pgru,   &
-                            pgtv, pgsv, pgrv  )
+
+   SUBROUTINE zps_hde( kt, kjpt, pta, pgtu, pgtv,   &
+                                 prd, pgru, pgrv    )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE zps_hde  ***
@@ -91,159 +86,27 @@
       !!          di(rho) = rd~ - rd(i,j,k) or rd (i+1,j,k) - rd~
       !!
-      !! ** Action  : - pgtu, pgsu, pgru: horizontal gradient of T, S
-      !!                and rd at U-points 
-      !!              - pgtv, pgsv, pgrv: horizontal gradient of T, S
+      !! ** Action  : - pgtu, pgtv: horizontal gradient of tracer at U/V-points
+      !!              - pgru, pgrv: horizontal gradient of rd if present at U/V-points 
       !!                and rd at V-points 
       !!----------------------------------------------------------------------
       !! * Arguments
-      INTEGER, INTENT( in ) ::   kt ! ocean time-step index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in )  :: ptem, psal, prd  ! 3D T, S and rd fields
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT( out ) :: pgtu, pgsu, pgru !  horizontal grad. of T, S and rd at u-point 
-      REAL(wp), DIMENSION(jpi,jpj)    , INTENT( out ) :: pgtv, pgsv, pgrv !  horizontal grad. of T, S and rd at v-point 
-      !! * Local declarations
-      INTEGER ::   ji , jj          ! Dummy loop indices
-      INTEGER ::   iku, ikv         ! partial step level at u- and v-points
-      REAL(wp), DIMENSION(jpi,jpj) ::   zti, ztj, zsi, zsj   ! interpolated value of T, S
-      REAL(wp), DIMENSION(jpi,jpj) ::   zri, zrj             ! interpolated value of rd
-      REAL(wp), DIMENSION(jpi,jpj) ::   zhgi, zhgj           ! depth of interpolation for eos2d
-      REAL(wp) :: ze3wu, ze3wv, zmaxu, zmaxv                 ! temporary scalars
-
-
-      ! Interpolation of T and S at the last ocean level
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
-# else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-# endif
-            ! last level
-            iku = mbatu(ji,jj)
-            ikv = mbatv(ji,jj)
-            ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
-            ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
-
-            ! i- direction
-            IF( ze3wu >= 0. ) THEN      ! case 1
-               ! interpolated values of T and S
-               zmaxu =  ze3wu / fse3w(ji+1,jj,iku)
-               zti(ji,jj) = ptem(ji+1,jj,iku) + zmaxu * ( ptem(ji+1,jj,iku-1) - ptem(ji+1,jj,iku) )
-               zsi(ji,jj) = psal(ji+1,jj,iku) + zmaxu * ( psal(ji+1,jj,iku-1) - psal(ji+1,jj,iku) )
-               ! depth of the partial step level
-               zhgi(ji,jj) = fsdept(ji,jj,iku)
-               ! gradient of T and S
-               pgtu(ji,jj) = umask(ji,jj,1) * ( zti(ji,jj) - ptem(ji,jj,iku) )
-               pgsu(ji,jj) = umask(ji,jj,1) * ( zsi(ji,jj) - psal(ji,jj,iku) )
-
-            ELSE                        ! case 2
-               ! interpolated values of T and S
-               zmaxu =  -ze3wu / fse3w(ji,jj,iku)
-               zti(ji,jj) = ptem(ji,jj,iku) + zmaxu * ( ptem(ji,jj,iku-1) - ptem(ji,jj,iku) )
-               zsi(ji,jj) = psal(ji,jj,iku) + zmaxu * ( psal(ji,jj,iku-1) - psal(ji,jj,iku) )
-               ! depth of the partial step level
-               zhgi(ji,jj) = fsdept(ji+1,jj,iku)
-               ! gradient of T and S 
-               pgtu(ji,jj) = umask(ji,jj,1) * ( ptem(ji+1,jj,iku) - zti (ji,jj) )
-               pgsu(ji,jj) = umask(ji,jj,1) * ( psal(ji+1,jj,iku) - zsi (ji,jj) )
-            ENDIF
-
-            ! j- direction
-            IF( ze3wv >= 0. ) THEN      ! case 1
-               ! interpolated values of T and S
-               zmaxv =  ze3wv / fse3w(ji,jj+1,ikv)
-               ztj(ji,jj) = ptem(ji,jj+1,ikv) + zmaxv * ( ptem(ji,jj+1,ikv-1) - ptem(ji,jj+1,ikv) )
-               zsj(ji,jj) = psal(ji,jj+1,ikv) + zmaxv * ( psal(ji,jj+1,ikv-1) - psal(ji,jj+1,ikv) )
-               ! depth of the partial step level
-               zhgj(ji,jj) = fsdept(ji,jj,ikv) 
-               ! gradient of T and S
-               pgtv(ji,jj) = vmask(ji,jj,1) * ( ztj(ji,jj) - ptem(ji,jj,ikv) )
-               pgsv(ji,jj) = vmask(ji,jj,1) * ( zsj(ji,jj) - psal(ji,jj,ikv) )
-
-            ELSE                        ! case 2
-               ! interpolated values of T and S
-               zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
-               ztj(ji,jj) = ptem(ji,jj,ikv) + zmaxv * ( ptem(ji,jj,ikv-1) - ptem(ji,jj,ikv) )
-               zsj(ji,jj) = psal(ji,jj,ikv) + zmaxv * ( psal(ji,jj,ikv-1) - psal(ji,jj,ikv) ) 
-               ! depth of the partial step level
-               zhgj(ji,jj) = fsdept(ji,jj+1,ikv) 
-               ! gradient of T and S
-               pgtv(ji,jj) = vmask(ji,jj,1) * ( ptem(ji,jj+1,ikv) - ztj(ji,jj) )
-               pgsv(ji,jj) = vmask(ji,jj,1) * ( psal(ji,jj+1,ikv) - zsj(ji,jj) )
-            ENDIF
-# if ! defined key_vectopt_loop
-         END DO
-# endif
-      END DO
-
-      ! Compute interpolated rd from zti, zsi, ztj, zsj for the 2 cases at the depth of the partial
-      ! step and store it in  zri, zrj for each  case
-      CALL eos( zti, zsi, zhgi, zri )
-      CALL eos( ztj, zsj, zhgj, zrj )
-
-
-      ! Gradient of density at the last level 
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
-# else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-# endif
-            iku = mbatu(ji,jj)
-            ikv = mbatv(ji,jj)
-            ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
-            ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
-            IF( ze3wu >= 0. ) THEN    ! i-direction: case 1
-               pgru(ji,jj) = umask(ji,jj,1) * ( zri(ji,jj) - prd(ji,jj,iku) )
-            ELSE                      ! i-direction: case 2
-               pgru(ji,jj) = umask(ji,jj,1) * ( prd(ji+1,jj,iku) - zri(ji,jj) )
-            ENDIF
-            IF( ze3wv >= 0. ) THEN    ! j-direction: case 1
-               pgrv(ji,jj) = vmask(ji,jj,1) * ( zrj(ji,jj) - prd(ji,jj,ikv) )  
-            ELSE                      ! j-direction: case 2
-               pgrv(ji,jj) = vmask(ji,jj,1) * ( prd(ji,jj+1,ikv) - zrj(ji,jj) )
-            ENDIF
-# if ! defined key_vectopt_loop
-         END DO
-# endif
-      END DO
-
-      ! Lateral boundary conditions on each gradient
-      CALL lbc_lnk( pgtu , 'U', -1. )   ;   CALL lbc_lnk( pgtv , 'V', -1. )
-      CALL lbc_lnk( pgsu , 'U', -1. )   ;   CALL lbc_lnk( pgsv , 'V', -1. )
-      CALL lbc_lnk( pgru , 'U', -1. )   ;   CALL lbc_lnk( pgrv , 'V', -1. )
-
-   END SUBROUTINE zps_hde
-
-#if defined key_top
-   !!----------------------------------------------------------------------
-   !!   'key_top'                                                TOP models
-   !!----------------------------------------------------------------------
-   SUBROUTINE zps_hde_trc ( kt, kjpt, ptra, pgtru, pgtrv )
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE zps_hde_trc  ***
-      !!                    
-      !! ** Purpose :   Compute the horizontal derivative of passive tracers
-      !!      TRA at u- and v-points with a linear interpolation for z-coordinate
-      !!      with partial steps.
-      !!
-      !! ** Method  :   the same for T & S
-      !!
-      !! ** Action  : - pgtru : horizontal gradient of TRA at U-points 
-      !!              - pgtrv : horizontal gradient of TRA at V-points 
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER                              , INTENT( in )  ::  kt    ! ocean time-step index
-      INTEGER                              , INTENT( in )  ::  kjpt  ! number of tracers
-      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT( in )  ::  ptra  ! 4D tracers fields
-      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT( out ) ::  pgtru, pgtrv  ! horizontal grad. of TRA u- and v-points 
+      INTEGER                              , INTENT( in )           ::  kt    ! ocean time-step index
+      INTEGER                              , INTENT( in )           ::  kjpt  ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT( in )           ::  pta   ! 4D active or passive tracers fields
+      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT( out)           ::  pgtu, pgtv  ! horizontal grad. of ptra u- and v-points 
+      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT( in ), OPTIONAL ::  prd   ! 3D rd fields
+      REAL(wp), DIMENSION(jpi,jpj         ), INTENT( out), OPTIONAL ::  pgru, pgrv  ! horizontal grad. of prd u- and v-points 
       !! * Local declarations
       INTEGER  ::   ji, jj, jn      ! Dummy loop indices
       INTEGER  ::   iku, ikv        ! partial step level at u- and v-points
-      REAL(wp) ::   ztrai, ztraj, ze3wu, ze3wv, zmaxu, zmaxv  ! temporary scalars
-      !!----------------------------------------------------------------------
-
+      REAL(wp), DIMENSION(jpi,jpj,kjpt) ::   zti, ztj     ! interpolated value of tracer
+      REAL(wp), DIMENSION(jpi,jpj)      ::   zri, zrj     ! interpolated value of rd
+      REAL(wp), DIMENSION(jpi,jpj)      ::   zhi, zhj     ! depth of interpolation for eos2d
+      REAL(wp) ::  ze3wu, ze3wv, zmaxu, zmaxv  ! temporary scalars
+      !!----------------------------------------------------------------------
+
+
+      ! Interpolation of tracers at the last ocean level
       DO jn = 1, kjpt
-         ! Interpolation of passive tracers at the last ocean level
 # if defined key_vectopt_loop
          jj = 1
@@ -262,14 +125,14 @@
                IF( ze3wu >= 0. ) THEN      ! case 1
                   zmaxu =  ze3wu / fse3w(ji+1,jj,iku)
-                  ! interpolated values of passive tracers
-                  ztrai = ptra(ji+1,jj,iku,jn) + zmaxu * ( ptra(ji+1,jj,iku-1,jn) - ptra(ji+1,jj,iku,jn) )
-                  ! gradient of passive tracers
-                  pgtru(ji,jj,jn) = umask(ji,jj,1) * ( ztrai - ptra(ji,jj,iku,jn) )
+                  ! interpolated values of tracers
+                  zti(ji,jj,jn) = pta(ji+1,jj,iku,jn) + zmaxu * ( pta(ji+1,jj,iku-1,jn) - pta(ji+1,jj,iku,jn) )
+                  ! gradient of  tracers
+                  pgtu(ji,jj,jn) = umask(ji,jj,1) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
                ELSE                        ! case 2
                   zmaxu = -ze3wu / fse3w(ji,jj,iku)
-                  ! interpolated values of passive tracers
-                  ztrai = ptra(ji,jj,iku,jn) + zmaxu * ( ptra(ji,jj,iku-1,jn) - ptra(ji,jj,iku,jn) )
-                  ! gradient of passive tracers
-                  pgtru(ji,jj,jn) = umask(ji,jj,1) * ( ptra(ji+1,jj,iku,jn) - ztrai )
+                  ! interpolated values of tracers
+                  zti(ji,jj,jn) = pta(ji,jj,iku,jn) + zmaxu * ( pta(ji,jj,iku-1,jn) - pta(ji,jj,iku,jn) )
+                  ! gradient of tracers
+                  pgtu(ji,jj,jn) = umask(ji,jj,1) * ( pta(ji+1,jj,iku,jn) - zti(ji,jj,jn) )
                ENDIF
 
@@ -277,14 +140,14 @@
                IF( ze3wv >= 0. ) THEN      ! case 1
                   zmaxv =  ze3wv / fse3w(ji,jj+1,ikv)
-                  ! interpolated values of passive tracers
-                  ztraj = ptra(ji,jj+1,ikv,jn) + zmaxv * ( ptra(ji,jj+1,ikv-1,jn) - ptra(ji,jj+1,ikv,jn) )
-                  ! gradient of passive tracers
-                  pgtrv(ji,jj,jn) = vmask(ji,jj,1) * ( ztraj - ptra(ji,jj,ikv,jn) )
+                  ! interpolated values of tracers
+                  ztj(ji,jj,jn) = pta(ji,jj+1,ikv,jn) + zmaxv * ( pta(ji,jj+1,ikv-1,jn) - pta(ji,jj+1,ikv,jn) )
+                  ! gradient of tracers
+                  pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( ztj(ji,jj,jn) - pta(ji,jj,ikv,jn) )
                ELSE                        ! case 2
                   zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
-                  ! interpolated values of passive tracers
-                  ztraj = ptra(ji,jj,ikv,jn) + zmaxv * ( ptra(ji,jj,ikv-1,jn) - ptra(ji,jj,ikv,jn) )
-                  ! gradient of passive tracers
-                  pgtrv(ji,jj,jn) = vmask(ji,jj,1) * ( ptra(ji,jj+1,ikv,jn) - ztraj )
+                  ! interpolated values of tracers
+                  ztj(ji,jj,jn) = pta(ji,jj,ikv,jn) + zmaxv * ( pta(ji,jj,ikv-1,jn) - pta(ji,jj,ikv,jn) )
+                  ! gradient of tracers
+                  pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( pta(ji,jj+1,ikv,jn) - ztj(ji,jj,jn) )
                ENDIF
 # if ! defined key_vectopt_loop
@@ -294,11 +157,76 @@
 
          ! Lateral boundary conditions on each gradient
-         CALL lbc_lnk( pgtru(:,:,jn) , 'U', -1. )
-         CALL lbc_lnk( pgtrv(:,:,jn) , 'V', -1. )
+         CALL lbc_lnk( pgtu(:,:,jn) , 'U', -1. )
+         CALL lbc_lnk( pgtv(:,:,jn) , 'V', -1. )
 
       END DO
 
-   END SUBROUTINE zps_hde_trc
-#endif
+      ! horizontal derivative of rd
+      IF( PRESENT( prd ) ) THEN
+         ! depth of the partial step level
+# if defined key_vectopt_loop
+         jj = 1
+         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
+# else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               iku = mbatu(ji,jj)
+               ikv = mbatv(ji,jj)
+               ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+               IF( ze3wu >= 0. ) THEN   
+                  zhi(ji,jj) = fsdept(ji  ,jj,iku)
+               ELSE                   
+                  zhi(ji,jj) = fsdept(ji+1,jj,iku)
+               ENDIF
+               IF( ze3wv >= 0. ) THEN  
+                  zhj(ji,jj) = fsdept(ji,jj  ,ikv)
+               ELSE                   
+                  zhj(ji,jj) = fsdept(ji,jj+1,ikv)
+               ENDIF
+# if ! defined key_vectopt_loop
+            END DO
+# endif
+         END DO
+
+         ! Compute interpolated rd from zti, ztj for the 2 cases at the depth of the partial
+         ! step and store it in  zri, zrj for each  case
+         CALL eos( zti, zhi, zri )
+         CALL eos( ztj, zhj, zrj )
+
+         ! Gradient of density at the last level 
+# if defined key_vectopt_loop
+         jj = 1
+         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
+# else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               iku = mbatu(ji,jj)
+               ikv = mbatv(ji,jj)
+               ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+               IF( ze3wu >= 0. ) THEN    ! i-direction: case 1
+                  pgru(ji,jj) = umask(ji,jj,1) * ( zri(ji,jj) - prd(ji,jj,iku) )
+               ELSE                      ! i-direction: case 2
+                  pgru(ji,jj) = umask(ji,jj,1) * ( prd(ji+1,jj,iku) - zri(ji,jj) )
+               ENDIF
+               IF( ze3wv >= 0. ) THEN    ! j-direction: case 1
+                  pgrv(ji,jj) = vmask(ji,jj,1) * ( zrj(ji,jj) - prd(ji,jj,ikv) )
+               ELSE                      ! j-direction: case 2
+                  pgrv(ji,jj) = vmask(ji,jj,1) * ( prd(ji,jj+1,ikv) - zrj(ji,jj) )
+               ENDIF
+# if ! defined key_vectopt_loop
+            END DO
+# endif
+         END DO
+
+         ! Lateral boundary conditions on each gradient
+         CALL lbc_lnk( pgru , 'U', -1. )   ;   CALL lbc_lnk( pgrv , 'V', -1. )
+         !
+      END IF
+      !
+   END SUBROUTINE zps_hde
 
    SUBROUTINE zps_hde_init
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 2082)
@@ -370,5 +370,5 @@
          zkepe(:,:,:) = 0.e0
    
-         CALL eos( tn, sn, rhd, rhop )       ! now potential and in situ densities
+         CALL eos( tsn, rhd, rhop )       ! now potential and in situ densities
 
          ! Density flux at w-point
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/istate.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/istate.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/istate.F90	(revision 2082)
@@ -42,4 +42,5 @@
    USE dynspg_exp      ! pressure gradient schemes
    USE dynspg_ts       ! pressure gradient schemes
+   USE traswp          ! Swap arrays                      (tra_swp routine)
    
    IMPLICIT NONE
@@ -122,10 +123,11 @@
          ENDIF
 
-         CALL eos( tb, sb, rhd, rhop )        ! before potential and in situ densities
+         ta(:,:,:) = 0.       ;     sa(:,:,:) = 0.
+         CALL tra_swap
+         CALL eos( tsb, rhd, rhop )        ! before potential and in situ densities
          
          IF( ln_zps .AND. .NOT. lk_c1d )   &
-            &             CALL zps_hde( nit000, tb, sb, rhd,  &  ! Partial steps: before Horizontal DErivative
-            &                                  gtu, gsu, gru, &  ! of t, s, rd at the bottom ocean level
-            &                                  gtv, gsv, grv )
+                          CALL zps_hde( nit000, 'TRA', tsb, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient
+            &                                          rhd, gru , grv , jpts )      ! of t, s, rd at the last ocean level
          
       ENDIF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/oce.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/oce.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/oce.F90	(revision 2082)
@@ -39,6 +39,6 @@
    !! interpolated gradient (only used in zps case)
    !! ---------------------
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   gtu, gsu, gru   !: horizontal gradient of T, S and rd at bottom u-point
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   gtv, gsv, grv   !: horizontal gradient of T, S and rd at bottom v-point 
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpts) ::   gtsu, gtsv !: horizontal gradient of T, S bottom u-point
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)      ::   gru , grv   !: horizontal gradient of rd at bottom u-point
 
    !! free surface                       !  before  !  now     !  after   !
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/opa.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/opa.F90	(revision 2081)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/opa.F90	(revision 2082)
@@ -37,5 +37,4 @@
    USE step_oce        ! Time stepping module definition
    USE sbc_oce         ! surface boundary condition: ocean
-   USE trdmod_oce      ! ocean variables trends
    USE domcfg          ! domain configuration               (dom_cfg routine)
    USE mppini          ! shared/distributed memory setting (mpp_init routine)
@@ -48,5 +47,4 @@
    USE zdfini
    USE phycst          ! physical constant                  (par_cst routine)
-   USE trdmod          ! momentum/tracers trends       (trd_mod_init routine)
    USE step            ! OPA time-stepping                  (stp     routine)
 #if defined key_oasis3
@@ -160,7 +158,5 @@
       !!
       !!----------------------------------------------------------------------
-#if defined key_oasis3 || defined key_oasis4 || defined key_iomput
       INTEGER :: ilocal_comm
-#endif
       CHARACTER(len=80),dimension(10) ::   cltxt = ''
       INTEGER                         ::   ji   ! local loop indices
@@ -192,4 +188,5 @@
       narea = mynode( cltxt, ilocal_comm )    ! Nodes selection (control print return in cltxt)
 # else
+      ilocal_comm = 0
       narea = mynode( cltxt )                 ! Nodes selection (control print return in cltxt)
 # endif
@@ -220,7 +217,7 @@
       !                             !--------------------------------!
 
-      CALL opa_flg                          ! Control prints & Benchmark
-
-                                            ! Domain decomposition
+      CALL opa_flg                           ! Control prints & Benchmark
+
+      !                                      ! Domain decomposition
       IF( jpni*jpnj == jpnij ) THEN   ;   CALL mpp_init      ! standard cutting out
       ELSE                            ;   CALL mpp_init2     ! eliminate land processors
@@ -231,4 +228,5 @@
      
 
+      !                                      ! General initialization
                             CALL     phy_cst    ! Physical constants
                             CALL     eos_init   ! Equation of state
@@ -245,20 +243,21 @@
 
       !                                     ! Ocean physics
-                            CALL     sbc_init   ! Read namsbc namelist : surface module (needed for iom_init)
-
-      !                                     ! Vertical physics
-                            CALL     zdf_init   ! namelist read
-                            CALL zdf_bfr_init   ! bottom friction
-      IF( lk_zdfric     )   CALL zdf_ric_init   ! Richardson number dependent Kz
-      IF( lk_zdftke_old )   CALL zdf_tke_init   ! TKE closure scheme for Kz (old scheme)
-      IF( lk_zdftke     )   CALL     tke_init   ! TKE closure scheme for Kz
-      IF( lk_zdfkpp     )   CALL zdf_kpp_init   ! KPP closure scheme for Kz
-      IF( lk_zdftmx     )   CALL zdf_tmx_init   ! tidal vertical mixing
+                            CALL     sbc_init   !  Forcings : surface module 
+
+      !                                         ! Vertical physics
+                            CALL     zdf_init      ! namelist read
+                            CALL zdf_bfr_init      ! bottom friction
+      IF( lk_zdfric     )   CALL zdf_ric_init      ! Richardson number dependent Kz
+      IF( lk_zdftke_old )   CALL zdf_tke_init      ! TKE closure scheme for Kz (old scheme)
+      IF( lk_zdftke     )   CALL     tke_init      ! TKE closure scheme for Kz
+      IF( lk_zdfkpp     )   CALL zdf_kpp_init      ! KPP closure scheme for Kz
+      IF( lk_zdftmx     )   CALL zdf_tmx_init      ! tidal vertical mixing
       IF( lk_zdfddm .AND. .NOT. lk_zdfkpp )   & 
-         &                  CALL zdf_ddm_init   ! double diffusive mixing
-      !                                     ! Lateral physics
-                            CALL ldf_tra_init   ! Lateral ocean tracer physics
-                            CALL ldf_dyn_init   ! Lateral ocean momentum physics
-      IF( lk_ldfslp )       CALL ldf_slp_init   ! slope of lateral mixing
+         &                  CALL zdf_ddm_init      ! double diffusive mixing
+      !                                         ! Lateral physics
+                            CALL ldf_tra_init      ! Lateral ocean tracer physics
+                            CALL ldf_dyn_init      ! Lateral ocean momentum physics
+      IF( lk_ldfslp )       CALL ldf_slp_init      ! slope of lateral mixing
+
       !                                     ! Active tracers
                             CALL tra_qsr_init   ! penetrative solar radiation qsr
@@ -280,7 +279,6 @@
 #if defined key_top
       !                                     ! Passive tracers
-                            CALL     trc_ini
-#endif
-
+                            CALL     trc_init
+#endif
       !                                     ! diagnostics
                             CALL     iom_init   ! iom_put initialization
